#include <iostream>
#include <memory>

using namespace std;

class Base
{
public:
    virtual void foo() = 0;
};

class Derived : public Base
{
public:
    void foo() override
    {
        cout << "Foo" << endl;
    }
};

template<typename T>
struct id { typedef T type; };

class Typer
{
public:
    typedef T Type;

    void base(const shared_ptr<Base> &base)
    {
        m_base = base;
    }

private:
    shared_ptr<Base> m_base;
};

int main(int argc, char *argv[])
{

    return 0;
}
